Upsert a contact
curl --request POST \
--url https://crm.example.com/public-api/v1/contacts/upsert \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"dbId": "user_42",
"name": "Ada Lovelace",
"emails": [
"ada@example.com"
],
"phones": [
"+14155550123"
]
}
'import requests
url = "https://crm.example.com/public-api/v1/contacts/upsert"
payload = {
"dbId": "user_42",
"name": "Ada Lovelace",
"emails": ["ada@example.com"],
"phones": ["+14155550123"]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
dbId: 'user_42',
name: 'Ada Lovelace',
emails: ['ada@example.com'],
phones: ['+14155550123']
})
};
fetch('https://crm.example.com/public-api/v1/contacts/upsert', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://crm.example.com/public-api/v1/contacts/upsert",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'dbId' => 'user_42',
'name' => 'Ada Lovelace',
'emails' => [
'ada@example.com'
],
'phones' => [
'+14155550123'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://crm.example.com/public-api/v1/contacts/upsert"
payload := strings.NewReader("{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://crm.example.com/public-api/v1/contacts/upsert")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://crm.example.com/public-api/v1/contacts/upsert")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"message": "Contact upserted",
"metaData": {
"warnings": [
"<string>"
]
},
"data": {
"id": "<string>",
"dbId": "user_42",
"name": "Ada Lovelace",
"kind": "person",
"emails": [
"ada@example.com"
],
"phones": [
"+14155550123"
],
"externalAccounts": [
{
"type": "stripe",
"value": "cus_123",
"createdAt": "2026-10-14T09:00:00.000Z"
}
],
"lifecycle": "unknown",
"unsubscribed": true,
"archived": true,
"createdAt": "<string>",
"updatedAt": "<string>"
}
}{
"type": "bad_request",
"message": "partyId: Invalid uuid"
}{
"type": "unauthorized",
"message": "Send a valid API key as Authorization: Bearer gd_key_…"
}{
"type": "limit_reached",
"message": "Your plan allows 1,000 contacts, and all are in use."
}{
"type": "rate_limited",
"message": "Rate limit reached. Retry in 30s."
}Contacts
Upsert a contact
Creates the contact the first time a dbId is seen and updates it every time after. Emails and phones are only ever added. The id it returns is the partyId every other route takes.
POST
/
v1
/
contacts
/
upsert
Upsert a contact
curl --request POST \
--url https://crm.example.com/public-api/v1/contacts/upsert \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"dbId": "user_42",
"name": "Ada Lovelace",
"emails": [
"ada@example.com"
],
"phones": [
"+14155550123"
]
}
'import requests
url = "https://crm.example.com/public-api/v1/contacts/upsert"
payload = {
"dbId": "user_42",
"name": "Ada Lovelace",
"emails": ["ada@example.com"],
"phones": ["+14155550123"]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
dbId: 'user_42',
name: 'Ada Lovelace',
emails: ['ada@example.com'],
phones: ['+14155550123']
})
};
fetch('https://crm.example.com/public-api/v1/contacts/upsert', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://crm.example.com/public-api/v1/contacts/upsert",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'dbId' => 'user_42',
'name' => 'Ada Lovelace',
'emails' => [
'ada@example.com'
],
'phones' => [
'+14155550123'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://crm.example.com/public-api/v1/contacts/upsert"
payload := strings.NewReader("{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://crm.example.com/public-api/v1/contacts/upsert")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://crm.example.com/public-api/v1/contacts/upsert")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"dbId\": \"user_42\",\n \"name\": \"Ada Lovelace\",\n \"emails\": [\n \"ada@example.com\"\n ],\n \"phones\": [\n \"+14155550123\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"message": "Contact upserted",
"metaData": {
"warnings": [
"<string>"
]
},
"data": {
"id": "<string>",
"dbId": "user_42",
"name": "Ada Lovelace",
"kind": "person",
"emails": [
"ada@example.com"
],
"phones": [
"+14155550123"
],
"externalAccounts": [
{
"type": "stripe",
"value": "cus_123",
"createdAt": "2026-10-14T09:00:00.000Z"
}
],
"lifecycle": "unknown",
"unsubscribed": true,
"archived": true,
"createdAt": "<string>",
"updatedAt": "<string>"
}
}{
"type": "bad_request",
"message": "partyId: Invalid uuid"
}{
"type": "unauthorized",
"message": "Send a valid API key as Authorization: Bearer gd_key_…"
}{
"type": "limit_reached",
"message": "Your plan allows 1,000 contacts, and all are in use."
}{
"type": "rate_limited",
"message": "Rate limit reached. Retry in 30s."
}Authorizations
Body
application/json